\ 430eforth-x-43n7vis : data-vocs --> vis-data-vocs-2204.fs           MM-220331
\ -----------------------------------------------------------------------------
\ MIT License (C) 2022 430eForth Workbench Project
\
\ Support for VIS based Data VOCabularies.
\ -----------------------------------------------------------------------------
  #require +field
  #require @cvoc

\ used:
\  +field  @cvoc

\ provided:
\  root words
\  field:  item:  ?u/i  ?voc  @cvoc
\ -----------------------------------------------------------------------------
  root definitions decimal

  DP @ aligned DP !  \ MM-220412: VARIABLE does not align the DP

  VARIABLE (v)       \ temporary context pointer for the array-maker

\ Abort with message if the transient VOCabulary search order isn't active.
: ?voc ( -- )
  [ UP $01A + literal ] ( VOCP ) @ 1 and 1- abort"  voc?"
;

\ Find and return the data item size ( u/i ) of the active VOCabulary.
: ?u/i ( -- u )
  ?voc $" u/i" [ ' [ 4 + @ ( xt-$interpret ) , ]
;

\ Create a data item of the active Data VOCabulary.
: item: ( "name" -- )  \ name ( -- a ; V: * )
 \ ?u/i item create here over allot swap 0 fill
   ?u/i dp @ aligned dp ! item create here over allot swap 0 fill
;

\ Create a data field of the active Data VOCabulary inside a data structure.
: field: ( "name" u1 -- u2 )  \ name ( a1 -- a2 ; V: * )
  ?u/i item +field 
;

forth definitions

\ Last revision: MM-220412  DP aligned in item: because CREATE doesn't do it.
\                           A data item must return a cell aligned address.

{ Data VOCabulary application hints:

\ How to define a simple data (variable) type :

#require cells

forth definitions

\ A Data VOCabulary for cell-sized integer variables.
  voc int  int definitions

\ The data size in address units.
  1 cells constant u/i 

\ The methods to acces the data.
  : @ ( a -- x ) forth @ ;
  : ! ( x a -- ) forth ! ;
  : ? ( a -- )   forth @ . ;

forth definitions

  int item: I1      \ or   int field: I2   in a data structure

\ 1234 i1 !   i1 @    i1 ?

}

